public class Employee {

    private static double BONUS;
//    public static double PUBLIC_BONUS;
    private String name;
    private String surname;
    private final int yearOfBirth;
    private String jobName;
    private String country;
    private String city;
    private String street;
    private double monthlySalaryGross;

    // alt + insert -> Generate constructor -> select all fields
    public Employee(String name, String surname, int yearOfBirth, String jobName, String country, String city,
                    String street, double monthlySalaryGross) {
        this.name = name;
        this.surname = surname;
        this.yearOfBirth = yearOfBirth;
        this.jobName = jobName;
        this.country = country;
        this.city = city;
        this.street = street;
        if(monthlySalaryGross >= 0 ) {
            this.monthlySalaryGross = monthlySalaryGross;
        } else {
            this.monthlySalaryGross = 0;
        }
    }

    public Employee() {
        this.yearOfBirth = 2000;
    }

    public Employee(int yearOfBirth) {
        this.yearOfBirth = yearOfBirth;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public int getYearOfBirth() {
        return yearOfBirth;
    }

    // yearOfBirth is final so the is no setter method

    public String getJobName() {
        return jobName;
    }

    public void setJobName(String jobName) {
        this.jobName = jobName;
    }

    public String getCountry() {
        return country;
    }

    public void setCountry(String country) {
        this.country = country;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getStreet() {
        return street;
    }

    public void setStreet(String street) {
        this.street = street;
    }

    public double getMonthlySalaryGross() {
        return monthlySalaryGross;
    }

    public void setMonthlySalaryGross(double monthlySalaryGross) {
        this.monthlySalaryGross = monthlySalaryGross;
    }

    public static double getBONUS() {
        return BONUS;
    }

    public static void setBONUS(double BONUS) {
        if(BONUS > 0) {
            Employee.BONUS = BONUS;
        } else {
            Employee.BONUS = 0;
        }
    }

    @Override
    public String toString() {
        return "Employee{" +
                "name='" + name + '\'' +
                ", surname='" + surname + '\'' +
                ", yearOfBirth=" + yearOfBirth +
                ", jobName='" + jobName + '\'' +
                ", country='" + country + '\'' +
                ", city='" + city + '\'' +
                ", street='" + street + '\'' +
                ", monthlySalaryGross=" + monthlySalaryGross +
                '}';
    }

    public void displayAddress() {
        System.out.println("Address:");
        System.out.println("Country :" + country);
        System.out.println("City :" + city);
        System.out.println("Street :" + street);
    }

    public void displayAllData() {
        System.out.println("Name and surname: " + name + " " + surname);
        System.out.println("Job name: " + jobName);
        System.out.println("Year of birth: " + yearOfBirth);
        displayAddress();
        System.out.println("Monthly salary gross: " + monthlySalaryGross + "EUR");
        System.out.println("All employee bonus: " + BONUS);
    }

    public double calculateGrossIncome() {
        return monthlySalaryGross * 12;
    }

    public double calculateGrossIncome(int numberOfMonths) {
        return monthlySalaryGross * numberOfMonths;
    }
}
